var $ = jQuery;
$(function() { 
	var tdClass = new Array();;
	var isFocusCell = false; // Стоит фокус или нет
	var oldRateCell;
	
	// Ставим фокус
	function tdFocus(thisObj, thisClass){
		tdClass = thisClass.split(' ');
		oldRateCell = thisObj.children('input').val();
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
	}
	
	// Убираем фокус
	function tdUnFocus(thisObj){
		oldRateCell = undefined;
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#fff');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#fff');
		});
	}
	
	function Rating(thisObj) {
		// Получаем подмодуль
		var reg = /col_\d+/;
		var col = ''+reg.exec(thisObj.attr('class'));
		col = $('.'+col+':first').attr('id');
		
		// Получаем студента
		var reg = /row_\d+/;
		var row = ''+reg.exec(thisObj.attr('class'));
		row = $('.'+row+':first').attr('id');
		
		var edit = false; // Типа говорим, что балл нужно добавить, а не изменить
		if (-1 < thisObj.attr('class').indexOf('edit'))
			edit = true; // Типа изменить балл

		if (oldRateCell != thisObj.children('input').val())
			if (edit) {
				$.post('/~dev_rating/handler/rating/changeRate', {'student': row, 'submodule': col, 'rate': thisObj.children('input').val() },
					function(data){
						alert(data);
					}
				);
			}
			else {
				$.post('/~dev_rating/handler/rating/setRate', {'student': row, 'submodule': col, 'rate': thisObj.children('input').val() },
					function(data){
						alert(data);
					}
				);
			}
	}
	
	$('.rateCell').mouseenter(function(){
		if (isFocusCell == false)
			tdFocus($(this), $(this).attr('class'));
	});
	
	$('.rateCell').mouseleave(function(){
		if (isFocusCell == false)
			tdUnFocus($(this));
	});
	
	$('.rateCell').focusin(function(){
		isFocusCell = true;
		tdFocus($(this), $(this).attr('class'));
	});
	
	$('.rateCell').focusout(function(){
		isFocusCell = false;
		Rating($(this));
		tdUnFocus($(this));
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$('.rateCell').children('input').keydown(function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
});
